//+------------------------------------------------------------------+
//|                                       IndicatorCrosslinesCCI.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 blue
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1
extern int Timeframe=0;
extern int limit=10000;
extern bool showlabels=true;
extern int period=55;
extern int applied_price=5;
extern int LineShift=1;
extern color resistanceColor=Red;
extern color supportColor=Blue;
extern int Labelsize=8;
extern int Linewidth=1;
extern bool calculateonbarclose=false;
extern bool showarrows=true;

                                                                                                             //
 double buyarrow[];
double sellarrow[];       
int periode;
string Symbolde;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
      IndicatorBuffers(2);
   SetIndexBuffer(0, buyarrow);
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(1, sellarrow);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
     for (int i = ObjectsTotal()-1; i>=0; i--) 
    {
     string tmp = ObjectName(i);
     if (StringFind(tmp,"Resistance") >= 0) ObjectDelete(tmp);
     if (StringFind(tmp,"Support") >= 0) ObjectDelete(tmp);
    }
   return(0);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
     int    counted_bars=IndicatorCounted(),i,z,b,drawresend=0,drawsupend=0;
   double indicatorvalue[];   
   ArrayResize(indicatorvalue,limit);
   double reshigh=0;
   double suplow=0;
   bool calculateit=false;
//----
if(calculateonbarclose)
{
   if(NewBar()||Period()!=periode||Symbol()!=Symbolde)
   {
      calculateit=true;
   }
   else
   calculateit=false;
}
else
calculateit=true;


if(calculateit)
{
periode=Period();
Symbolde=Symbol();
   for(i=limit;i>=0;i--)
   {
      indicatorvalue[i]=iCCI(NULL,Timeframe,period,applied_price,iBarShift(NULL,Timeframe,iTime(NULL,0,i)));
      if(i<(limit))
      {
         if(indicatorvalue[i+1]>0&&indicatorvalue[i+0]<0)
         {
            drawresend=Resistbars(i+LineShift);
            if(ObjectFind("Resistance"+"CCI"+period+Time[i]+Timeframe)==-1)
            {
            DrawRes(drawresend,i);
            

            reshigh=iHigh(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift)));
            }
            else
            ObjectSet("Resistance"+"CCI"+period+Time[i]+Timeframe,OBJPROP_TIME2,iTime(NULL,0,drawresend));
            if(showarrows)
            sellarrow[i]=High[i]+0.4*iATR(NULL,0,14,i);
            else
            sellarrow[i]=EMPTY_VALUE;

            
         }
         else
         sellarrow[i]=EMPTY_VALUE;
         
         if(indicatorvalue[i+1]>0&&indicatorvalue[i+0]>0)
         {
            if(ObjectFind("Resistance"+"CCI"+period+Time[i]+Timeframe)!=-1)
            {            
               ObjectDelete("Resistance"+"CCI"+period+Time[i]+Timeframe);
               
               ObjectDelete("Resistance"+"label"+"CCI"+period+Time[i]+Timeframe);
            }
         }
         
         if(showlabels&&(iBarShift(NULL,Timeframe,iTime(NULL,0,i))-iBarShift(NULL,Timeframe,iTime(NULL,0,drawresend)))>3)
         {
         if(ObjectFind("Resistance"+"CCI"+period+Time[i]+Timeframe)!=-1)
         {
            if(ObjectFind("Resistance"+"label"+"CCI"+period+Time[i]+Timeframe)==-1)
            {
            ObjectCreate("Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,OBJ_TEXT,0,Time[drawresend+4],reshigh);
            ObjectSetText("Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,"CCIRes"+"("+period+")"+"_"+Timeframe);
            ObjectSet("Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,OBJPROP_COLOR,resistanceColor); 
            ObjectSet("Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,OBJPROP_FONTSIZE,Labelsize);
            }
            else
            ObjectMove("Resistance"+"label"+"CCI"+period+Time[i]+Timeframe,1,Time[drawresend+4],reshigh);
         }         
         }
         if(indicatorvalue[i+1]<0&&indicatorvalue[i]>0)
         {
            drawsupend=Supportbars(i+LineShift);
            if(ObjectFind("Support"+"CCI"+period+Time[i]+Timeframe)==-1)
            {
            ObjectCreate("Support"+"CCI"+period+Time[i]+Timeframe,OBJ_TREND,0,iTime(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift))),iLow(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift))),iTime(NULL,0,drawsupend),iLow(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift))));
            ObjectSet("Support"+"CCI"+period+Time[i]+Timeframe,OBJPROP_RAY,false);
            ObjectSet("Support"+"CCI"+period+Time[i]+Timeframe,OBJPROP_COLOR,supportColor);
            ObjectSet("Support"+"CCI"+period+Time[i]+Timeframe,OBJPROP_WIDTH,Linewidth);
            suplow=iLow(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,i+LineShift)));
            }
            else
            ObjectSet("Support"+"CCI"+period+Time[i]+Timeframe,OBJPROP_TIME2,iTime(NULL,0,drawsupend));
            
            if(showarrows)            
            buyarrow[i]=Low[i]-0.2*iATR(NULL,0,14,i);
            else
            buyarrow[i]=EMPTY_VALUE;
            

            
         } 
         else
         buyarrow[i]=EMPTY_VALUE;
         if(indicatorvalue[i+1]<0&&indicatorvalue[i+0]<0)
         {
            if(ObjectFind("Support"+"CCI"+period+Time[i]+Timeframe)!=-1)
            {            
               ObjectDelete("Support"+"CCI"+period+Time[i]+Timeframe);
               ObjectDelete("Support"+"label"+"CCI"+period+Time[i]+Timeframe);
            }
         }   
         
         if(showlabels&&(iBarShift(NULL,Timeframe,iTime(NULL,0,i))-iBarShift(NULL,Timeframe,iTime(NULL,0,drawsupend)))>3)
            {
                        if(ObjectFind("Support"+"CCI"+period+Time[i]+Timeframe)!=-1)
            {
               if(ObjectFind("Support"+"label"+"CCI"+period+Time[i]+Timeframe)==-1)
               {
               ObjectCreate("Support"+"label"+"CCI"+period+Time[i]+Timeframe,OBJ_TEXT,0,Time[drawsupend+4],suplow);
               ObjectSetText("Support"+"label"+"CCI"+period+Time[i]+Timeframe,"CCISup"+"("+period+")"+"_"+Timeframe);
               ObjectSet("Support"+"label"+"CCI"+period+Time[i]+Timeframe,OBJPROP_COLOR,supportColor);
               ObjectSet("Support"+"label"+"CCI"+period+Time[i]+Timeframe,OBJPROP_FONTSIZE,Labelsize);
               }
               else
               ObjectMove("Support"+"label"+"CCI"+period+Time[i]+Timeframe,1,Time[drawsupend+4],suplow);
            }     
         }

               

         
         
      }
      
   }
            
}   
//----
   return(0);
  }
//+------------------------------------------------------------------+

int Resistbars(int Shift)
 {
     int rbars=0;
     for(int xi=Shift-1;xi>=0;xi--)
     {
         if(iHigh(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,Shift)))<High[xi])
         {
         rbars=xi; xi=0;
         }
         else
         rbars=xi;
     }           
     return(rbars);
 }
 
int Supportbars(int Shift)
 {
     int rbars=0;
     for(int xi=Shift-1;xi>=0;xi--)
     {
         if(iLow(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,Shift)))>Low[xi])
         {
         rbars=xi; xi=0;
         }
         else
         rbars=xi;
     }           
     
     return(rbars);
 }
 bool NewBar()

{

   static datetime lastbar;

   datetime curbar = Time[0];

   if(lastbar!=curbar)

   {

      lastbar=curbar;

      return (true);

   }

   else return(false);

}
  
  
  
void DrawRes(int drawiresend,int resi)
{
            
            ObjectCreate("Resistance"+"CCI"+period+Time[resi]+Timeframe,OBJ_TREND,0,iTime(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,resi+LineShift))),iHigh(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,resi+LineShift))),iTime(NULL,0,drawiresend),iHigh(NULL,Timeframe,iBarShift(NULL,Timeframe,iTime(NULL,0,resi+LineShift))));
            ObjectSet("Resistance"+"CCI"+period+Time[resi]+Timeframe,OBJPROP_RAY,false);
            ObjectSet("Resistance"+"CCI"+period+Time[resi]+Timeframe,OBJPROP_COLOR,resistanceColor);
            ObjectSet("Resistance"+"CCI"+period+Time[resi]+Timeframe,OBJPROP_WIDTH,Linewidth);
            return(0);
}
  
  